
var dev = false;

var MAPTYPE_SPACE	= "space";
var MAPTYPE_PLANET	= "planet";
var MAPTYPE_SPLASH	= "splash";

var ACTION_INIT		= "initializing";
var ACTION_INTRO	= "intro";
var ACTION_OUTTRO	= "rrrrausss";
var ACTION_PLAY		= "play";
var ACTION_PAUSE	= "pause";
var ACTION_LIFTOFF	= "liftoff";

var ACTION_DONE		= "done";


var config = {
		"debug" : {},
		"pixi" : {
			"canvas" : {}
			},
		"game" : {},
		"space" : {
			"ship" : {},
			"movement" : {},
			"planet" : {
				"color" : {},
				"radius" : {}
				},
			"planets" : {},
			"world" : {},
			"target" : {
				"color" : {}
			}
			},
		"planet" : {
			"ship" : {},
			"color" : {},
			"ellipse" : {}
		},
		
};

	config.frameno = 0;
	config.exhaustimg = 0;
	config.exhausttype = 1;

	config.planetContact = 0;

// DEBUG
	
	config.debug.showBB = false;
	config.debug.showMovement = false;


// PIXI
//=========
	config.pixi.canvas.width	= 800;
	config.pixi.canvas.height	= 600;

//  GAME
// =========
	config.game.maptype = MAPTYPE_SPLASH;	// we start with the splash
	config.game.starttime = 0;
	config.game.timer	= 0;
	config.game.winning = false;
	config.game.loosing = false;

//  SPACE
// =========

	config.space.pause = false;
	config.space.fading = false;
	config.space.alpha	= 1;
	config.space.hidden	= false;
	
	config.space.world.width = 800;
	config.space.world.height = 600;
	config.space.world.offsx = 0;
	config.space.world.offsy = config.pixi.canvas.height - config.space.world.height;
	
	config.space.bkgrcolor = 0x333333;
	config.space.movement.minx = 20;
	config.space.movement.miny = 20;
	config.space.movement.maxx = config.pixi.canvas.width - 20;
	config.space.movement.maxy = config.pixi.canvas.height - 20;
	
	
	
	//  :PLANETS
	
		config.space.planets.list		= [];
		config.space.planets.count		= 0;
		config.space.planets.density	= 200;
		config.space.planets.minsize	= 10;
		config.space.planets.maxsize	= 20;
		config.space.planets.minborder	= 2;
		config.space.planets.maxborder	= 12;
		config.space.planets.mindist	= (config.space.planets.maxsize+config.space.planets.maxborder)*2 + 20;
		
		config.space.planets.distmaxtry	= 100;
		config.space.planets.distmaxrec	= 10;
	
	//  :TARGET
		
		config.space.target.radiusearth	= 17;
		config.space.target.color.earth		= 0xCC6633;
		config.space.target.color.earthalpha = 1;
		config.space.target.color.earthalias = 0xb36633;
		config.space.target.color.earthaliasalpha = 0.5;
		
		config.space.target.radiusskymed	= 23;
		config.space.target.color.skymed	= 0x006633;
		config.space.target.color.skymedalpha = 0.55;
		config.space.target.color.skymedalias = 0x194d33;
		config.space.target.color.skymedaliasalpha = 0.4;
		
		
	//  :PLANET
		
		config.space.planet.shiprotation = Math.PI/4;
		config.space.planet.radius.earth	= 75;
		config.space.planet.radius.skylow	= 92;
		config.space.planet.radius.skymed	= 130;
		config.space.planet.shipoffset		= 7;
		
		//config.space.planet.color.earth		= 0x00974B;
		config.space.planet.color.earth		= 0x028859;
		config.space.planet.color.earthalpha = 1;
		//config.space.planet.color.earthalias = 0x067170;
		config.space.planet.color.earthalias = 0x0b6d65;
		config.space.planet.color.earthaliasalpha = 0.5;
		
		config.space.planet.color.skylow	= 0x006699;
		config.space.planet.color.skylowalpha = 0.55;
		config.space.planet.color.skylowalias = 0x115578;
		config.space.planet.color.skylowaliasalpha = 0.4;
		
		config.space.planet.color.skymed	= 0x115578;
		config.space.planet.color.skymedalpha = 0.55;
		config.space.planet.color.skymedalias = 0x1e485d;
		config.space.planet.color.skymedaliasalpha = 0.4;

	
	//	:SHIP
		config.space.ship.zoom				= 0.20;	
	
		config.space.ship.rotation_speed	= 0.05;
		config.space.ship.rotation_curr		= 0;
		config.space.ship.movement_speed	= 2;
		
		config.space.ship.speed				= 0;
		config.space.ship.speed_accaccu		= 0;
		config.space.ship.speed_acc			= 0.001;
		config.space.ship.speed_dec			= 0.001;
		config.space.ship.speed_max			= 1.5;
		
		config.space.ship.started			= false;
		config.space.ship.accelerating		= false;


		
//  PLANET
// =========
	
	//	: SHIP
		
		config.planet.alpha	= 1;
		
		config.planet.obstacles = {};
		config.planet.objects = {};
		config.planet.objects.wormholes = [];
		config.planet.obstacles.initoffs 	= 0;
		config.planet.obstacles.initspread 	= 1000;
		config.planet.obstacles.currentoffs = 0;
		
		config.planet.timePerWormhole	= 444;
		
		config.planet.obstacles.scrollspeed = 4;
		
		config.planet.obstacles.resetbuffer = -100;		// when the x value is below this threshold, the obstacle will be recycled
		config.planet.obstacles.skyscraper = [];
		config.planet.maxobstacles	= 100;
		
		config.planet.ship.started	= false;
		config.planet.ship.movement_speed = 7;
		config.planet.ship.movingTo = false;
		config.planet.ship.moving	= false;
		config.planet.ship.scale	= 0.25
	
		config.planet.ellipse.width	= 600;
		config.planet.ellipse.height= 200;
		
		config.planet.color.earth	= 0xAA6600;
		config.planet.color.surface	= 0x336633;
		config.planet.color.skylow	= 0x86BBFD;
		config.planet.color.skymed	= 0xB8D8FE;
		config.planet.color.skyhigh	= 0xDDECFF;
		config.planet.color.space	= 0xB9CCDB;

	